module OO
  module Errors
    class LicenseMissing < StandardError
      attr_reader :user_data, :license_key

      def initialize(attrs = {})
        @user_data = attrs[:user_data]
        @license_key = attrs.fetch(:license_key)
        super(error_message)
      end

      private

      def error_message
        msg = "User "
        msg << "#{user_data} " unless user_data.nil?
        msg << "is missing permission '#{license_key}'. " \
               'Therefore he is not allowed to perform this activity.'
      end
    end
  end
end
